#!/bin/sh
synolxa=2.6.32
synofam=88f628x
synolva=5004
synolvb=5510
synopat=linux-${synolxa}-${synofam}-${synolva}-to-${synolvb}-v2.patch

if [ ! -e ${synopat} ]; then
  synopat=linux-${synolxa}-${synofam}-${synolva}-to-${synolvb}.patch
fi

if [ "X$1" != "X" ]; then
  synolva=$1
fi
if [ "X$2" != "X" ]; then
  synolvb=$2
fi
if [ "X$3" != "X" ]; then
  synopat=$3
fi

diffsign=+
filtsign=-
diffud=B
filtud=A
if [ "X$4" = "X-r" ]; then
  echo "reverse"
  diffsign=-
  filtsign=+
  diffud=A
  filtud=B
fi

#cat ${synopat} | sed "s|/\*.*\*/||g" | sed 's|//.*$||g' | grep -A11 -B11 'MY_..._HERE' | sed -r ':a; s%(.*)/\*.*\*/%\1%; ta; /\/\*/ !b; N; ba' | sed /'^-$'/d | sed /'^\+$'/d | sed /'^\+..$'/d | sed /'^-.$'/d| sed /'^-..$'/d | \
#  grep -${diffud}1 -E '^\'${diffsign}'#ifdef.*MY_ABC_HERE' | \
#  grep -${filtud}1 '#ifdef.*SYNO_' | \
#  grep -A3 -B2 CONFIG_SYNO_LOWER_MD_RESYNC_NICE


cat ${synopat} | sed "s|/\*.*\*/||g" | sed 's|//.*$||g' | sed /'^-$'/d | sed /'^\+$'/d | sed /'^\+..$'/d | sed /'^-.$'/d| sed /'^-..$'/d | grep -${diffud}1 -E '^\'${diffsign}'#ifdef.*MY_ABC_HERE' | \
  grep -${filtud}1 '#ifdef.*SYNO_' | grep -${diffud}1 -E '^\'${diffsign}'#ifdef.*MY_ABC_HERE' | grep SYNO_ | \
  sed s/'^\'${filtsign}'#ifdef '/''/g | sed s/'^\'${filtsign}'#ifdef.SYNO_'/'SYNO_'/g | sed s/'^\'${filtsign}'#ifdef.CONFIG_SYNO_'/'CONFIG_SYNO_'/g | tr -d ' ' | sort | uniq > _defabc-${synolva}-on.txt

cat ${synopat} | sed "s|/\*.*\*/||g" | sed 's|//.*$||g' | sed /'^-$'/d | sed /'^\+$'/d | sed /'^\+..$'/d | sed /'^-.$'/d| sed /'^-..$'/d | grep -${diffud}1 -E '^\'${diffsign}'#ifndef.*MY_ABC_HERE' | \
  grep -${filtud}1 '#ifndef.*SYNO_' | grep -${diffud}1 -E '^\'${diffsign}'#ifndef.*MY_ABC_HERE' | grep SYNO_ | \
  sed s/'^\'${filtsign}'#ifndef '/''/g | sed s/'^\'${filtsign}'#ifndef.SYNO_'/'SYNO_'/g | sed s/'^\'${filtsign}'#ifndef.CONFIG_SYNO_'/'CONFIG_SYNO_'/g | tr -d ' ' | sort | uniq >> _defabc-${synolva}-on.txt

cat ${synopat} | sed "s|/\*.*\*/||g" | sed 's|//.*$||g' | sed /'^-$'/d | sed /'^\+$'/d | sed /'^\+..$'/d | sed /'^-.$'/d| sed /'^-..$'/d | sed s/'#if.defined.('/'#if defined('/g | sed s/'&&.*'/''/g | sed s/'||.*'/''/g | \
  grep -${diffud}1 '^\'${diffsign}'#if defined(MY_ABC_HERE)$' | \
  grep -${filtud}1 '^\'${filtsign}'#if defined(.*SYNO_.*)$' | grep -${diffud}1 '^\'${diffsign}'#if defined(MY_ABC_HERE)$' | grep SYNO_ | \
  sed s/'.#if defined'/''/g | tr -d '() ' | sort | uniq >> _defabc-${synolva}-on.txt

mv _defabc-${synolva}-on.txt _defabc-${synolva}-on1.txt
cat _defabc-${synolva}-on-extra.txt >> _defabc-${synolva}-on1.txt
cat _defabc-${synolva}-on1.txt | sort | uniq > _defabc-${synolva}-on.txt


#cat ${synopat} | sed "s|/\*.*\*/||g" | sed 's|//.*$||g' | grep -A11 -B11 'MY_..._HERE' | sed -r ':a; s%(.*)/\*.*\*/%\1%; ta; /\/\*/ !b; N; ba' | sed /'^-$'/d | sed /'^\+$'/d | sed /'^\+..$'/d | sed /'^-.$'/d | sed /'^-..$'/d | \
#  grep -A3 -B2 CONFIG_SYNO_USB_BUGGY_PORT_RESET_BIT_QUIRK

cat ${synopat} | sed "s|/\*.*\*/||g" | sed 's|//.*$||g' | sed /'^-$'/d | sed /'^\+$'/d | sed /'^\+..$'/d | sed /'^-.$'/d | sed /'^-..$'/d | grep -${diffud}1 -E '^\'${diffsign}'#ifdef.*MY_DEF_HERE' | \
  grep -${filtud}1 '#ifdef.*SYNO_' | grep -${diffud}1 -E '^\'${diffsign}'#ifdef.*MY_DEF_HERE' | grep SYNO_ | \
  sed s/'^\'${filtsign}'#ifdef '/''/g | sed s/'^\'${filtsign}'#ifdef.SYNO_'/'SYNO_'/g | sed s/'^\'${filtsign}'#ifdef.CONFIG_SYNO_'/'CONFIG_SYNO_'/g | tr -d ' ' | sort | uniq > _defabc-${synolva}-off.txt

cat ${synopat} | sed "s|/\*.*\*/||g" | sed 's|//.*$||g' | sed /'^-$'/d | sed /'^\+$'/d | sed /'^\+..$'/d | sed /'^-.$'/d | sed /'^-..$'/d | grep -${diffud}1 -E '^\'${diffsign}'#ifndef.*MY_DEF_HERE' | \
  grep -${filtud}1 '#ifndef.*SYNO_' | grep -${diffud}1 -E '^\'${diffsign}'#ifndef.*MY_DEF_HERE' | grep SYNO_ | \
  sed s/'^\'${filtsign}'#ifndef '/''/g | sed s/'^\'${filtsign}'#ifndef.SYNO_'/'SYNO_'/g | sed s/'^\'${filtsign}'#ifndef.CONFIG_SYNO_'/'CONFIG_SYNO_'/g | tr -d ' ' | sort | uniq >> _defabc-${synolva}-off.txt

cat ${synopat} | sed "s|/\*.*\*/||g" | sed 's|//.*$||g' | sed /'^-$'/d | sed /'^\+$'/d | sed /'^\+..$'/d | sed /'^-.$'/d| sed /'^-..$'/d | sed s/'#if.defined.('/'#if defined('/g | sed s/'&&.*'/''/g | sed s/'||.*'/''/g | \
  grep -${diffud}1 '^\'${diffsign}'#if defined(MY_DEF_HERE)$' | \
  grep -${filtud}1 '^\'${filtsign}'#if defined(.*SYNO_.*)$' | grep -${diffud}1 '^\'${diffsign}'#if defined(MY_DEF_HERE)$' | grep SYNO_ | \
  sed s/'.#if defined'/''/g | tr -d '() ' | sort | uniq >> _defabc-${synolva}-off.txt

mv _defabc-${synolva}-off.txt _defabc-${synolva}-off1.txt
cat _defabc-${synolva}-off-extra.txt >> _defabc-${synolva}-off1.txt
cat _defabc-${synolva}-off1.txt | sort | uniq > _defabc-${synolva}-off.txt
