synolxa=linux-3.2.40-4458-patched1
synolst=_defabc

if [ "X$1" != "X" ]; then
  synolxa=$1
fi
if [ "X$2" != "X" -a -e $2-files.txt ]; then
  synolst=$2
fi

echo "Using ${synolxa} with ${synolst}-files.txt"

#cd linux-3.x
cd ${synolxa}

#if false ; then
for f in `cat ../${synolst}-files.txt` ; do
  if [ -e $f ]; then
  if grep -q -E 'MY_DEF_HERE|MY_ABC_HERE|SYNO_|ARCH_GEN3' $f ; then
  echo $f
  for d in `cat ../${synolst}-off.txt` ; do
  #for d in `cat ../${synolst}-off.txt ../${synolst}-off-alpine.txt ../${synolst}-off-armada370.txt` ; do
    if grep -q ${d} $f ; then
    sed -i "s/defined(${d})/defined(MY_DEF_HERE)/g" $f
    sed -i "s/defined (${d})/defined (MY_DEF_HERE)/g" $f
    sed -i "s/defined( ${d})/defined( MY_DEF_HERE)/g" $f
    sed -i "s/defined ${d})/defined MY_DEF_HERE)/g" $f
    sed -i "s/defined ${d} /defined MY_DEF_HERE /g" $f
    sed -i "s/DEFINED(${d})/DEFINED(MY_DEF_HERE)/g" $f

    sed -i "s/ifdef ${d}$/ifdef MY_DEF_HERE/g" $f
    sed -i "s/^#ifdef  ${d}$/#ifdef MY_DEF_HERE/g" $f
    sed -i "s/^#ifdef  ${d} /#ifdef MY_DEF_HERE /g" $f
    sed -i "s/^#ifdef ${d} /#ifdef MY_DEF_HERE /g" $f
    #sed -i "s/^#ifdef ${d} /#ifdef MY_DEF_HERE /g" $f
    sed -i "s/^#ifdef ${d}"')'"/#ifdef MY_DEF_HERE/g" $f
    sed -i "s|ifdef ${d} //|ifdef MY_DEF_HERE //|g" $f
    sed -i "s|ifdef ${d} /\*|ifdef MY_DEF_HERE /*|g" $f
    sed -i "s/ifdef ${d}  $/ifdef MY_DEF_HERE  /g" $f
    sed -i s/'^#ifdef\t'${d}/'#ifdef\tMY_DEF_HERE'/g $f
    sed -i "s/ifdef ${d}			$/ifdef MY_DEF_HERE			/g" $f
    sed -i "s/ifndef ${d}$/ifndef MY_DEF_HERE/g" $f
    sed -i "s/ifndef ${d} /ifndef MY_DEF_HERE /g" $f
    sed -i "s/else !${d}$/else !MY_DEF_HERE/g" $f

    sed -i "s|else // ${d}$|else // MY_DEF_HERE|g" $f
    sed -i "s|else // !${d}$|else // !MY_DEF_HERE|g" $f
    sed -i "s|endif // ${d}$|endif // MY_DEF_HERE|g" $f
    sed -i "s|endif // ${d}	$|endif // MY_DEF_HERE	|g" $f
    sed -i "s|endif //end of ${d}$|endif //end of MY_DEF_HERE|g" $f
    sed -i "s|endif // end of ${d}$|endif // end of MY_DEF_HERE|g" $f
    sed -i "s|endif // end of not ${d}$|endif // end of not MY_DEF_HERE|g" $f
    sed -i "s|endif /\* ${d} \*/|endif /* MY_DEF_HERE */|g" $f
    sed -i "s|endif /\* ${d} |endif /* MY_DEF_HERE |g" $f

    sed -i 's|/\*'${d}'\*/$|/*MY_DEF_HERE*/|g' $f
    sed -i 's|/\* '${d}' \*/$|/* MY_DEF_HERE */|g' $f
    sed -i 's|//'${d}'$|//MY_DEF_HERE|g' $f
    sed -i 's|/\*'${d}' \*/$|/*MY_DEF_HERE */|g' $f
    sed -i 's|/\* !'${d}' \*/$|/* !MY_DEF_HERE */|g' $f
    sed -i 's@/\* !'${d}' || @/* !MY_DEF_HERE || @g' $f
    sed -i 's@/\* '${d}' ||@/* MY_DEF_HERE ||@g' $f
    sed -i 's@/\* '${d}' &&@/* MY_DEF_HERE \&\&@g' $f
    sed -i 's@/\* ('${d}' ||@/* (MY_DEF_HERE ||@g' $f
    sed -i 's@|| '${d}' \*/@|| MY_DEF_HERE */@g' $f
    sed -i 's@ || '${d}') @ || MY_DEF_HERE) @g' $f
    sed -i 's@|| ('${d}' && @|| (MY_DEF_HERE \&\& @g' $f

    sed -i 's|#ifdef '${d}'\t$|#ifdef MY_DEF_HERE\t|g' $f
    sed -i 's|// END of '${d}'$|// END of MY_DEF_HERE|g' $f
    sed -i 's|#endif /\* '${d}'\*/$|#endif /* MY_DEF_HERE*/|g' $f
    sed -i 's| defined '${d}'$| defined MY_DEF_HERE|g' $f

    sed -i 's|^#if '${d}'$|#ifdef MY_DEF_HERE|g' $f
    sed -i 's|^#elif '${d}'$|#elif MY_DEF_HERE|g' $f
    fi
  done
  for d in `cat ../${synolst}-on.txt` ; do
  #for d in `cat ../${synolst}-on.txt ../${synolst}-on-comcerto2k.txt` ; do
    if grep -q ${d} $f ; then
    sed -i "s/defined(${d})/defined(MY_ABC_HERE)/g" $f
    sed -i "s/defined (${d})/defined (MY_ABC_HERE)/g" $f
    sed -i "s/defined( ${d})/defined( MY_ABC_HERE)/g" $f
    sed -i "s/defined ${d})/defined MY_ABC_HERE)/g" $f
    sed -i "s/defined ${d} /defined MY_ABC_HERE /g" $f
    sed -i "s/DEFINED(${d})/DEFINED(MY_ABC_HERE)/g" $f

    sed -i "s/ifdef ${d}$/ifdef MY_ABC_HERE/g" $f
    sed -i "s/^#ifdef  ${d}$/#ifdef MY_ABC_HERE/g" $f
    sed -i "s/^#ifdef  ${d} /#ifdef MY_ABC_HERE /g" $f
    sed -i "s/ifdef"$'\t'"${d}$/ifdef"$'\t'"MY_ABC_HERE/g" $f
    sed -i "s/^#ifdef"$'\t'"${d}/#ifdef"$'\t'"MY_ABC_HERE/g" $f
    sed -i "s/^#ifdef ${d} /#ifdef MY_ABC_HERE /g" $f
    sed -i "s/ifdef ${d}  $/ifdef MY_ABC_HERE  /g" $f
    sed -i s/'^#ifdef\t'${d}/'#ifdef\tMY_ABC_HERE'/g $f
    sed -i "s/ifdef ${d}			$/ifdef MY_ABC_HERE			/g" $f
    sed -i "s/ifndef ${d}$/ifndef MY_ABC_HERE/g" $f
    sed -i "s/ifndef ${d} /ifndef MY_ABC_HERE /g" $f
    sed -i "s/else !${d}$/else !MY_ABC_HERE/g" $f

    sed -i "s|else // ${d}$|else // MY_ABC_HERE|g" $f
    sed -i "s|else // !${d}$|else // !MY_ABC_HERE|g" $f
    sed -i "s|endif // ${d}$|endif // MY_ABC_HERE|g" $f
    sed -i "s|endif // ${d}	$|endif // MY_ABC_HERE	|g" $f
    sed -i "s|endif //end of ${d}$|endif //end of MY_ABC_HERE|g" $f
    sed -i "s|endif // end of ${d}$|endif // end of MY_ABC_HERE|g" $f
    sed -i "s|endif // end of not ${d}$|endif // end of not MY_ABC_HERE|g" $f
    sed -i "s|endif /\* ${d} \*/|endif /* MY_ABC_HERE */|g" $f
    sed -i "s|endif /\* ${d} |endif /* MY_ABC_HERE |g" $f

    sed -i 's|/\*'${d}'\*/$|/*MY_ABC_HERE*/|g' $f
    sed -i 's|/\* '${d}' \*/$|/* MY_ABC_HERE */|g' $f
    sed -i 's|//'${d}'$|//MY_ABC_HERE|g' $f
    sed -i 's|/\*'${d}' \*/$|/*MY_ABC_HERE */|g' $f
    sed -i 's|/\* !'${d}' \*/$|/* !MY_ABC_HERE */|g' $f
    sed -i 's@/\* '${d}' ||@/* MY_ABC_HERE ||@g' $f
    sed -i 's@/\* ('${d}' ||@/* (MY_ABC_HERE ||@g' $f
    sed -i 's@|| '${d}' \*/@|| MY_ABC_HERE */@g' $f
    sed -i 's@ || '${d}') @ || MY_ABC_HERE) @g' $f

    sed -i 's|#ifdef '${d}'\t$|#ifdef MY_ABC_HERE\t|g' $f
    sed -i 's|// END of '${d}'$|// END of MY_ABC_HERE|g' $f
    sed -i 's|#endif /\* '${d}'\*/$|#endif /* MY_ABC_HERE*/|g' $f
    sed -i 's| defined '${d}'$| defined MY_ABC_HERE|g' $f

    sed -i 's|^#if '${d}'$|#ifdef MY_ABC_HERE|g' $f
    sed -i 's|^#elif '${d}'$|#elif MY_ABC_HERE|g' $f
    fi
  done
  else
    echo "skip: $f"
  fi
  else
    echo "not found: $f"
  fi
done
#fi

havearmada=false
for f in synoconfigs/armada* ; do
  if [ -e $f ]; then
    havearmada=true
  fi
done

#if [ $havearmada = true ]; then
#  sed -i s/armv7-marvell-linux-gnueabi-hard/arm-unknown-linux-gnueabi/g synoconfigs/armada*
#  sed -i s/arm-marvell-linux-gnueabi/arm-unknown-linux-gnueabi/g        synoconfigs/armada*
#fi
